"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.GenericDatasourceQueryCtrl = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _sdk = require("app/plugins/sdk");

require("./css/query-editor.css!");

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DimensionRow = function DimensionRow() {
    _classCallCheck(this, DimensionRow);

    this.key = 'select dimension';
    this.value = 'dimension value';
    this.alias = '';
};

var GenericDatasourceQueryCtrl = exports.GenericDatasourceQueryCtrl = function (_QueryCtrl) {
    _inherits(GenericDatasourceQueryCtrl, _QueryCtrl);

    function GenericDatasourceQueryCtrl($scope, $injector, uiSegmentSrv) {
        _classCallCheck(this, GenericDatasourceQueryCtrl);

        var _this = _possibleConstructorReturn(this, (GenericDatasourceQueryCtrl.__proto__ || Object.getPrototypeOf(GenericDatasourceQueryCtrl)).call(this, $scope, $injector));

        _this.uiSegmentSrv = uiSegmentSrv;

        _this.target.dimensionArray = _this.initializeDimensionArray();

        _this.refreshSpectrumParameters();

        _this.createWatchCollectionOnDimensions($scope);
        return _this;
    }

    _createClass(GenericDatasourceQueryCtrl, [{
        key: "initializeDimensionArray",
        value: function initializeDimensionArray() {
            var empty = this.target.dimensionArray == null || this.target.dimensionArray === null || this.target.dimensionArray.length <= 0;

            return empty ? [new DimensionRow()] : this.target.dimensionArray;
        }
    }, {
        key: "createWatchCollectionOnDimensions",
        value: function createWatchCollectionOnDimensions(scope) {
            var _this2 = this;

            scope.$watchCollection('ctrl.target.dimensionArray', function (oldVal, newVal) {
                _this2.onChangeInternal();
            });
        }
    }, {
        key: "refreshSpectrumParameters",
        value: function refreshSpectrumParameters() {
            this.target.namespace = this.target.namespace || 'select namespace';
            this.target.metricName = this.target.metricName || 'select metric';
            this.target.dimensionAlias = this.target.dimensionAlias || '';

            this.target.statistic = this.target.statistic || 'average';
            this.target.interval = this.target.interval || '1m';

            this.datasource.spectrumParameters = {
                namespace: this.target.namespace,
                metricName: this.target.metricName,
                interval: this.target.interval,
                statistic: this.target.statistic,
                dimensions: this.target.dimensionArray
            };
        }
    }, {
        key: "onChangeInternal",
        value: function onChangeInternal() {
            this.refreshSpectrumParameters();
            this.panelCtrl.refresh(); // Asks the panel to refresh data.
        }

        // TODO: To improve UI performance and flow we need to fetch entire hierarchy of: namespace, metric & dimensions
        // TODO: and manipulate the drop downs logic on the client side

    }, {
        key: "getNamespaces",
        value: function getNamespaces() {
            return this.datasource.getNamespaces(this.target).then(this.uiSegmentSrv.transformToSegments(false));
            // Options have to be transformed by uiSegmentSrv to be usable by metric-segment-model directive
        }
    }, {
        key: "getMetrics",
        value: function getMetrics() {
            return this.datasource.getMetrics(this.target).then(this.uiSegmentSrv.transformToSegments(false));
            // Options have to be transformed by uiSegmentSrv to be usable by metric-segment-model directive
        }
    }, {
        key: "getDimensions",
        value: function getDimensions() {
            return this.datasource.getDimensions(this.target).then(this.uiSegmentSrv.transformToSegments(false));
            // Options have to be transformed by uiSegmentSrv to be usable by metric-segment-model directive
        }
    }, {
        key: "addDimensionRow",
        value: function addDimensionRow() {
            if (this.target.dimensionArray !== null) {
                this.target.dimensionArray.push(new DimensionRow());
            }
        }
    }, {
        key: "removeDimensionRow",
        value: function removeDimensionRow(index) {
            if (this.target.dimensionArray !== null && index > -1) {
                this.target.dimensionArray.splice(index, 1);
            }
        }
    }]);

    return GenericDatasourceQueryCtrl;
}(_sdk.QueryCtrl);

GenericDatasourceQueryCtrl.templateUrl = 'partials/query.editor.html';
//# sourceMappingURL=query_ctrl.js.map
